Subject: bug#10736: Add "underwave" face attribute

From: Alp Aker <[email-masked]>
Date: Thu, 12 Apr 2012 20:49:17 -0400

On Thu, Apr 12, 2012 at 5:57 PM, Stefan Monnier
<[email-masked]> wrote:
> Assuming the code is OK, yes.   I'd like to hear someone's opinion on
> the code, tho (Jan, maybe?).

Looking afresh at the small bit I contributed for ns_draw_underwave,
it seems to me that that function does some unnecessary work with
clipping rectangles, so I'd like to offer a slightly simpler version
(revised patch file attached).

(In explanation of this change:  If I understand the NS port's drawing
routine correctly, at the time this function is called the current
clipping path has already been restricted to the glyph string's clip
rects.  Since NSRectClip can only further restrict the current
clipping path, there's no need explicitly to invoke the glyph string's
clip rects at this point.  Indeed, I suspect the NS version could get
away without worrying about clipping at all here, but I'm not as
certain of this latter point.)